import { ComponentPublicInstance, ComponentInternalInstance } from 'vue';
declare type Provider<T> = T & {
    link(child: ComponentInternalInstance): void;
    unlink(child: ComponentInternalInstance): void;
    children: ComponentPublicInstance[];
    internalChildren: ComponentInternalInstance[];
};
declare const useProvider: <T>(key: string | symbol) => {
    context: Omit<Provider<T>, "link" | "unlink" | "internalChildren">;
    idx: number;
} | {
    context: null;
    idx: number;
};
export { useProvider };
